<template lang="pug">
    mdb-modal(:show="show" @close="$emit('editModalClosed')" :success="isCreate" :info="!isCreate")
        mdb-modal-header
            mdb-modal-title {{ isCreate ? "Add New Task" : "Modify Task" }}
        mdb-modal-body
            mdb-input(v-model="task.title" label="Name of Task*" class="mt-5" maxlength="200")
            mdb-input(v-model="task.description" type="textarea" label="Description" :rows="3" class="mt-5")
            datetime(v-model="task.time" type="time" input-id="startDate" class="mt-5")
                label(for="startDate" slot="after") Time*
        mdb-modal-footer
            mdb-btn.float-right(v-if="isCreate" color="success" @click="$emit('create', task)") Create
            mdb-btn.float-right(v-if="!isCreate" color="info" @click="$emit('save', task)") Save
            mdb-btn.float-right(v-if="!isCreate" color="danger" @click="$emit('delete')") Delete
            mdb-btn.float-right(color="blue-grey" @click="$emit('editModalClosed')") Cancel
</template>

<script>

import moment from 'moment';

export default {
    name: 'editModal',
    props: {
        show: {
            type: Boolean,
            default: false
        },
        taskToEdit: {
            type: Object
        }
    },
    data() {
        return {
            emptyTask: {
                title: '',
                description: '',
                time: ''
            },
            task: {}
        }
    },
    computed: {
        isCreate () {
            return Object.keys(this.taskToEdit).length === 0 ? true : false
        }
    },
    methods: {
        correctDateTimeField () {
            // this is a correction of the datetime element to look like the other material design input fields
            const inputfield = document.getElementsByClassName('vdatetime-input')
            inputfield[0].classList.add('form-control', 'p-0')

            const field = document.getElementsByClassName('vdatetime')
            if (this.task.time && this.task.time !== '') {
                field[0].querySelector('label').classList.add('active')
            } else if (field[0] !== undefined) {
                field[0].querySelector('label').classList.remove('active')
            }
        }
    },
    updated() {
        this.correctDateTimeField()
    },
    watch: {
        show: {
            handler () {
                if (this.isCreate){
                    this.task = JSON.parse(JSON.stringify(this.emptyTask))
                } else {
                    this.task = JSON.parse(JSON.stringify(this.taskToEdit))
                }
            }
        }
    }
}
</script>
